!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine EddyViscosity
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: eddyviscosity.f90,v 1.2 2005/01/28 12:41:21 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ήͥ륮ȤαȻ, Ǵ. 
!ήѥ᥿ꥼ, Mellor and Yamada (1974) 
!Level 1 Closure б뤬, Level1 Closure ¸ߤ 
!\bar{\theta^2} ̵뤵Ƥ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!ήͥ륮ˤʤä, .
!
!== Future Plans
!
                                                                 !=end

subroutine EddyViscosity(fs_VelX_n, sf_VelZ_n, ss_PotTemp_n, &
     &                   ss_Km_n, ss_Kh_n)
                                                                 !=begin
  !== Dependency
  use timeset,  only: DelTimeLong
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax, DelX
  use average,  only: ss_avr_ff, ss_avr_sf
  use arareprm, only: Cm, Grav
  use differentiate_center2, only: ss_dx_fs, sf_dz_ss, ff_dx_sf, ff_dz_fs, ss_dz_sf
  use basicset, only: ss_PotTempBasicZ
  use bcset,    only: ss_BC
                                                                 !=end  
  !--- ۤηػ
  implicit none
                                                                 !=begin  
  !== Input
  real(8), intent(in)  :: &
       & fs_VelX_n(DimXMin:DimXMax, DimZMin:DimZMax) !® u
  real(8), intent(in)  :: &
       & sf_VelZ_n(DimXMin:DimXMax, DimZMin:DimZMax) !® w
  real(8), intent(in)  :: &
       & ss_PotTemp_n(DimXMin:DimXMax, DimZMin:DimZMax) !

  !== Output
  real(8), intent(out) :: &
       & ss_Km_n(DimXMin:DimXMax, DimZMin:DimZMax) !Ǵ
  real(8), intent(out) :: &
       & ss_Kh_n(DimXMin:DimXMax, DimZMin:DimZMax) !Ȼ
                                                                 !=end  
  !--- ѿ
  real(8)  :: ss_Km2_n(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: Max
  

  !--- Ǵ
  ss_Km2_n = &
       & ( Cm ** 2.0d0 ) * ( DelX ** 4.0d0 ) &
       &   * (                                & 
       &        2.0d0 * ( ss_dx_fs( fs_VelX_n ) ** 2.0d0 )  &
       &      + 2.0d0 * ( ss_dz_sf( sf_VelZ_n ) ** 2.0d0 )  &
       &      + ss_avr_ff(                                  &
       &          ( ff_dx_sf( sf_VelZ_n ) + ff_dz_fs( fs_VelX_n ) )** 2.0d0 &
       &        ) &
       &      - 3.0d0 * Grav * ss_avr_sf( &
       &          ( sf_dz_ss( ss_PotTemp_n ) / ss_PotTempBasicZ )  &
       &        ) &
       &      )

  !--- ͤĴ. deepconv 
  where ( ss_Km2_n < 0.0d0 ) 
     ss_Km2_n = 0.0d0
  end where

  Max = ( DelX ** 2.0d0 ) / ( 2.0d0 * DelTimeLong )
  where ( ss_Km2_n > (Max ** 2.0d0) ) 
     ss_Km2_n = Max ** 2.0d0
  end where

  !--- 
  ss_Km_n = sqrt( ss_Km2_n )
  ss_Kh_n = 3.0d0 * ss_Km_n 

!  ss_Km_n = 0.0d0
!  ss_Kh_n = 0.0d0

  !--- 
  call boundary( ss_BC, ss_Km_n )
  call boundary( ss_BC, ss_Kh_n )
  
end subroutine EddyViscosity
