!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine AdvectVelZ
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: advectvelz.f90,v 1.4 2005/02/02 10:07:26 odakker Exp $
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview
!
! Z αưΰή׻. ư 2 Ȥ. 
! AdvZ = u \DP{u}{z} + w \DP{w}{z}
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!
                                                                 !=end

subroutine AdvectVelZ(fs_VelX_B, sf_VelZ_B, sf_AdvZ_B)
                                                                 !=begin
  !== Dependency
  use dc_trace,      only: BeginSub, EndSub 
  use gridset,        only: DimXMin, DimXMax, DimZMin, DimZMax 
  use average,       only: sf_avr_ff, ff_avr_fs, sf_avr_ss, ss_avr_sf
  use differentiate_center2, only: ff_dx_sf, ss_dz_sf
                                                                 !=end
  !--- ۤηػ
  implicit none
                                                                 !=begin  
  !== input
  real(8), intent(in)     :: fs_VelX_B(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)     :: sf_VelZ_B(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end
                                                                 !=begin
  !== output
  real(8), intent(out)    :: sf_AdvZ_B(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end

  call BeginSub("AdvectVelZ", &
&               fmt="%c",       &
&               c1="Calculate advection term for VelZ (sf_AdvZ_B).")

  !--- ή 
  sf_AdvZ_B = &
       &   sf_avr_ff( ff_avr_fs( fs_VelX_B ) * ff_dx_sf( sf_VelZ_B ) ) &
       & + sf_avr_ss( ss_avr_sf( sf_VelZ_B ) * ss_dz_sf( sf_VelZ_B ) ) 
  
  call EndSub("AdvectVelZ")

end subroutine AdvectVelZ
